/**************************************************************************************************

Copyright (c) 2007-2015   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_FONT_H__
#define __MTK_FONT_H__
#include  "../common/text/unicode.h"
#include  <string>
#include  <vector>



//-- ̕\@
enum {
	TEXT_DEFAULT,
	TEXT_LEFT,
	TEXT_CENTER,
	TEXT_RIGHT
};




bool	init_FT();
void	free_FT();
bool	init_font_face(const char* sys_font_path, const std::vector<std::string>& vfont, int face_index);
void	free_font_face();


//--  redering size
void	set_font_rendering_sizes(int bmp_sz, int char_sz);


//--  size
void	get_text_size(const std::string& text, float& w, float& h);
int		get_text_size_raw(const std::string& text, float& w, float& h);

//--  draw
void	draw_text_raw(const std::string& text, const float &D);
void	draw_text(const std::string& text, bool bDrawRuby = true);
void	draw_textf(const char* szFormat, ...);

//--  centering
void	draw_text_centering(const std::string& text, bool bDrawRuby=true);
void	draw_text_right(const std::string& text, bool bDrawRuby = true);

void	draw_text_line(const std::string& str, char pos, bool bNewLine);





//--  output
void	output_bmp_font(const char* fn, int page, int lv);





#endif
