/**************************************************************************************************

Written by Tsunehiko Kato
Copyright (c) 2015   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __UNICODE_STRING_TABLE_H__
#define __UNICODE_STRING_TABLE_H__
#include  <stdio.h>
#include  <vector>
#include  <map>
#include  <string>
#include  "unicode_string.h"




//-------------------------------
//  class  unocode_string_table
//-------------------------------
class unicode_string_table
{
	std::vector<std::string > vStrings;
	std::map<std::string, int>  key_ID_map;
	std::vector<std::string> vKey;


public:
	//--  Init
	void	clear();

	//--  Size
	int		size() const  { return vStrings.size(); }

	//--  Get
	int				get_ID(const std::string& key)  const;
	bool			is_defined_key(const std::string& key) const	{ return  (get_ID(key) >= 0); }
	const std::string&	get_string(const std::string& key)  const;
	const std::string&	get_string(int ID)  const				{ return vStrings[ID]; }
	const std::string&	get_key(int ID)     const				{ return vKey[ID]; }

	//--  Add
	int		set_string(const std::string& key, const std::string& str);

	//--  Load
	bool	load_utf8(FILE *fp, const std::string& lang_id);
};




#endif
