/**************************************************************************************************

Written by Tsunehiko Kato
Copyright (c) 2008-2015   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_date.h"
#include  "mtk_strings.h"





std::string
make_date_string(int year, int month, int day)
{
	const char month_key[12][10] = {
		"MONTH_1",  "MONTH_2",  "MONTH_3",  "MONTH_4",
		"MONTH_5",  "MONTH_6",  "MONTH_7",  "MONTH_8",
		"MONTH_9",  "MONTH_10", "MONTH_11", "MONTH_12"
	};
	char tmp[100];


	if (month <= 0)  month = 1;
	if (month > 12)  month = 12;


	const std::string& fmt = get_string("DATE_FMT");



	//---  parse
	const char* ps = &fmt[0];
	std::string date;
	char ch;

	while ((ch=*ps) != '\0') {
		if (ch != '%') {
			date.push_back(ch);
			ps++;
			continue;
		}

		ps++;
		ch=*ps++;
		if (ch=='\0') break;

		switch (ch) {
			case 'y':	case 'Y':
				sprintf(tmp, "%4d", year);
				date += std::string(tmp);
				break;
			case 'm':	case 'M':
				date += get_string(month_key[month-1]);
				break;
			case 'd':	case 'D':
				sprintf(tmp, "%2d", day);
				date += std::string(tmp);
				break;
			default:
				date += '%';
				date += ch;
				break;
		}
	}

	return  date;
}

